HDU 2995 Robberies (01变形,概率dp)

题面

Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input
3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output
2
4
6

思路

一眼背包,不过还是会有点区别,刚开始的想法就是把金钱当做价值,概率作为容量,但是显然对于这题来说,浮点数的枚举可能十分困难。这个时候我们考虑一下变形,把容量当做偷取的金钱,价值则为概率,当我们计算完所有的dp数组,从最大元素和开始反向枚举,如果偷取它的概率大于我失败的概率,那么我们就找出了最大值,直接退出即可。(最近大作业有点小烦,刷题都不安心,吐槽hdu的校赛还在期末考试前几天,不说了,逃去睡了),最后贴下代码。

代码实现

#include<cstdio>
#include<algorithm>
#include<cstring>
#include<iostream>
using namespace std;
const int maxn=10005;
int n, t;
double dp[maxn], pbest, x[maxn];
int val[maxn], fin;
int main () {
    cin>>t;
    while (t--) {
        memset (dp,0,sizeof (dp));
        cin>>pbest>>n;
        fin = 0;
        for (int i=1;i<=n;i++) cin>>val[i]>>x[i],fin+=val[i];
        dp[0]=1;
        for (int i=1;i<=n;i++) 
         for (int j=fin;j>=val[i];j--) {
             dp[j]=max(dp[j-val[i]]*(1-x[i]),dp[j]);
         }
         for (int i=fin;i>=0;i--) {
            if (dp[i]>=(1-pbest)) {
              cout<<i<<endl;
              break;
         }
    }
    }
    return 0;
}
原文地址:https://www.cnblogs.com/hhlya/p/13111359.html